#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int    *iVector(long, long);
float  *fVector(long, long);
double *dVector(long, long);
float  **fMatrix(long, long, long, long);
double **dMatrix(long, long, long, long);
void free_iVector(int     *, long, long);
void free_fVector(float   *, long, long);
void free_dVector(double  *, long, long);
void free_dMatrix(double **, long, long, long, long);
void free_fMatrix(float  **, long, long, long, long);

double hmmlogs(double **, double **, int, int, char *);

FILE *stream;

extern int nseq;

int getrms(double *ret_hscore, double RMSmin)
{
	float **x_old, **x_oldk, **x_new;
	int   len_oldk, len_newk;

	int   i, k;
	float fp1, fp2, fp3, fp4, fp5, fp6, fp7, fp8, fp9, fp10;
	double hscore;
	double **xmod, **xque;
	int lenq, lenm;

	char *hmmID;
	float tst;

    *ret_hscore = 7.77;

    x_old       = fMatrix(1,3,1,2*nseq);
    x_oldk      = fMatrix(1,3,1,2*nseq);
    x_new       = fMatrix(1,3,1,2*nseq);

    stream = fopen( "que.dat", "r" );
	if( stream == NULL )
	   printf( "Couldn't open file QUE.DAT\n" );
	else   {
    fscanf( stream, "%i\n", &len_oldk);

lenq = len_oldk;
xque = dMatrix(1,lenq,1,3);

	for(i=1;i<=len_oldk;i++) {
    fscanf( stream, "%f %f %f\n", &fp1, &fp2, &fp3);
      x_old[1][i]=fp1;
      x_old[2][i]=fp2;
      x_old[3][i]=fp3;
      x_old[1][i+len_oldk]=fp1;
      x_old[2][i+len_oldk]=fp2;
      x_old[3][i+len_oldk]=fp3;
      x_oldk[1][i]=fp1;
      x_oldk[2][i]=fp2;
      x_oldk[3][i]=fp3;
      x_oldk[1][i+len_oldk]=fp1;
      x_oldk[2][i+len_oldk]=fp2;
      x_oldk[3][i+len_oldk]=fp3;
	}
    fclose( stream );
	}

    stream = fopen( "corextract.out", "r" );
	if( stream == NULL )
	   printf( "Couldn't open file corextract.out!\n" );
	else   {
    fscanf( stream, "%i\n", &len_newk);

lenm = len_newk;
xmod = dMatrix(1,lenm,0,9);

	for(i=1;i<=len_newk;i++) {
    fscanf( stream, "%f %f %f %f %f %f %f %f %f %f\n", 
		&fp1, &fp2, &fp3, &fp4, &fp5, &fp6, &fp7, &fp8, &fp9, &fp10);
	xmod[i][0] = fp10;
	xmod[i][1] = fp1;
	xmod[i][2] = fp2;
	xmod[i][3] = fp3;
	xmod[i][4] = fp4;
	xmod[i][5] = fp5;
	xmod[i][6] = fp6;
	xmod[i][7] = fp7;
	xmod[i][8] = fp8;
	xmod[i][9] = fp9;

      x_new[1][i]=fp1;
      x_new[2][i]=fp2;
      x_new[3][i]=fp3;
      x_new[1][i+len_newk]=x_new[1][i];
      x_new[2][i+len_newk]=x_new[2][i];
      x_new[3][i+len_newk]=x_new[3][i];
	}
    fclose( stream );
	}

/*
 printf("\n First 10 coordinates of the unaligned query:\n" );
 for(k=len_oldk+1; k<=len_oldk+10; k++) 
 {
 printf("%f %f %f\n", x_old[1][k], x_old[2][k], x_old[3][k] );
 }

 printf("\n First 10 coordinates of the model:\n" );
 for(k=len_newk+1; k<=len_newk+10; k++) 
 {
 printf("%f %f %f\n", x_new[1][k], x_new[2][k], x_new[3][k] );
 }

 	printf("lengths: %d %d\n", len_oldk, len_newk);

	for(k=1; k<=115; k++) 
	{
		printf("%d %d %d\n", k, iin_oldk[k], jin_newk[k]);
	}
*/
/* Recalculate **xmod and **xque matrices */

for(i=len_newk+1;i<=2*len_newk;i++) {
	xmod[i-len_newk][1] = x_new[1][i];
	xmod[i-len_newk][2] = x_new[2][i];
	xmod[i-len_newk][3] = x_new[3][i];
}
for(i=len_oldk+1;i<=2*len_oldk;i++) {
	xque[i-len_oldk][1] = x_old[1][i];
	xque[i-len_oldk][2] = x_old[2][i];
	xque[i-len_oldk][3] = x_old[3][i];
}

/* Call hmmlogs to score the aligned query: */

hmmID = (char *)malloc(20*sizeof(char));
strcpy(hmmID, "hmmparams.dat"); /* Created by perl script */
tst = 4;

hscore = hmmlogs(xmod, xque, lenm, lenq, hmmID);

*ret_hscore = hscore;

stream = fopen( "output.dat", "w" );
if( stream == NULL )
   printf( "Couldn't open file output.dat!\n" );
else {
	fprintf(stream, "Aligned query:\n" );
	for(k=len_oldk+1; k<=2*len_oldk /* +10 */ /*len_oldk*/; k++) 
	{
		fprintf(stream, "%f %f %f\n", x_old[1][k], x_old[2][k], x_old[3][k] );
	}
	fprintf(stream, "rmsbes = %f\n",RMSmin);
	fprintf(stream, "hmmscore = %f\n",hscore);
/*	printf("\nhmmscore = %f\n\n",hscore); */
	fclose( stream );
} /* else */

free(hmmID);

/*  FREE MEMORY and RETURN to Smain: */
    free_fMatrix(x_old,1,3,1,2*nseq);
    free_fMatrix(x_oldk,1,3,1,2*nseq);
    free_fMatrix(x_new,1,3,1,2*nseq);
	free_dMatrix(xmod,1,lenm,0,9);
	free_dMatrix(xque,1,lenq,1,3);

	return 7;
}
