#!/usr/bin/perl

# this goes with the 3d HMM server.  see cgi-bin/hmmstr.cgi.
# -Nat

if(!scalar(@ARGV)) { 
  print "Proper syntaxis for this program is: perl provepdb.pl <filename> \n"; 
  exit;
}
$filename = $ARGV[0];
$nProcessed = ProvePDB("$filename");
# print "Processed $nProcessed atoms from $filename \n"; 

sub ProvePDB{ #("$filename")
  my $filename = shift;  
  my (@qca,@qx,@qy,@qz,@chainname,$nque_atoms);
  my (@qatom,@qna,@qaa,@qnaa); # use only if need all PDB info
  undef @qca; undef @qx; undef @qy; undef @qz; undef @chainname;
  undef @qatom; undef @qna; undef @qaa; undef @qnaa;
  undef $line, $nque_atoms;
  open(INP,"< $filename")||die "Query input open error!";
    while (<INP>) {
      if (/ATOM\s+\d+\s+CA/ ) {
        $line=$_;    #redefines $_ (funky perl variable) as $line
        $qatom[$nque_atoms]=substr($line,6,5); #note:  following values are based on 0-start arrays!
        $qna[$nque_atoms]=substr($line,12,4);
        $qca[$nque_atoms]=substr($line,17,3);
        $chainname[$nque_atoms]=substr($line,21,1);
        $chainname[$nque_atoms] = 'L' if($chainname[$nque_atoms] eq ' ');
        $qaa[$nque_atoms]=~ s/ /_/;
        $qnaa[$nque_atoms]=substr($line,22,4);
        $qx[$nque_atoms]=substr($line,30,8);
        $qy[$nque_atoms]=substr($line,38,8);
        $qz[$nque_atoms]=substr($line,46,8);
        $nque_atoms++;
      }
      if (/^ENDMDL/) {        #loop to close file if >1 NMR structure
        close INP;
      }
    } #while
  close INP;

  if($nque_atoms == 0) {
     print "Your query file does not seem to have valid PDB format.\n";
     exit 0;
  } #if
  
#  open(OUT,"> $filename") || die "Query input open error!";
  open(OUT,"> query.pdb") || die "Query input open error!";
  $i=0;
  for(@qx) {  
    printf OUT "%4s%7d%4s%5s%2s%4d%12.3f%8.3f%8.3f\n", "ATOM", $i+1, "CA",
                $qca[$i], $chainname[$i], $i+1, $qx[$i], $qy[$i], $qz[$i];			   		  
    $i++;
  }
  close OUT;
  
  return $nque_atoms;  
} # ProvePDB
